2610 REMark Quicksort, faster variety, by Marcus Jeffery
2620 :
2630 REMark prepare an array to sort, remembering that this routine needs
2640 REMark a predefined 'highest value entry' at the end of the array
2650 REMark QUICKSORT2 also needs the procedure QS2_PARTITION below
2660 DEFine PROCedure QUICKSORT2 (array,lower,upper)
2670   LOCal part_elem
2680   IF lower < upper THEN
2690     part_elem = upper + 1
2700     QS2_PARTITION lower,part_elem
2710     QUICKSORT2 array,lower,part_elem-1
2720     QUICKSORT2 array,part_elem+1,upper
2730   END IF
2740 END DEFine QUICKSORT2
2750 :
2760 DEFine PROCedure QS2_PARTITION (i,j)
2770   LOCal k,temp$,swap$,loop,inc_k,dec_j,swap
2780   temp$ = array(i) : k = i
2790   REPeat loop
2800     REPeat inc_k
2810       k = k + 1
2820       REMark this is where the 'guaranteed highest value' comes in
2830       IF array(k) >= temp$ THEN EXIT inc_k
2840     END REPeat inc_k
2850     REPeat dec_j
2860       j = j - 1
2870       REMark conversely we don't need a 'guaranteed less than' value
2880       REMark at the start of the array as the sorting process does
2890       REMark this for us anyway
2900       IF array(j) <= temp$ THEN EXIT dec_j
2910     END REPeat dec_j
2920     IF k < j THEN
2930       REMark swap the two entries around
2940       swap$ = array(k) : array(k) = array(j) : array(j) = swap$
2950     ELSE
2960       EXIT loop
2970     END IF
2980   END REPeat loop
2990   array(i) = array(j) : array(j) = temp$
3000 END DEFine QS2_PARTITION
