100 REMark test the sort routines
110 CLS : CLS #0
120 :
130 INPUT 'Sort how many entries ? ';entries%
140 IF entries% = 0 THEN STOP
150 :
160 PRINT\'Select data type to sort:'
170 PRINT '1 - Random'
180 PRINT '2 - Ascending'
190 PRINT '3 - Descending'
200 PRINT '4 - Word list'
210 INPUT 'Enter 1-4 : ';sort_type
220 IF sort_type = 0 THEN STOP
230 :
240 DIM array1$(entries%-1,10),array2$(entries%-1,10)
250 REMark array1$() contains the master copy
260 SELect ON sort_type
270   =1 : REMark random data
280     FOR a = 0 TO entries%-1
290       array1$(a) = 'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz0123456789'(RND(1 TO 62))
300     END FOR a
310   =2 : REMark ascending order data
320     REMark make uniform length numeric data strings
330     datlen = LEN(entries%)
340     FOR a = 0 TO entries% - 1
350       temp$ = ''
360       IF LEN(a) < datlen THEN temp$ = '000000'(1 TO datlen-LEN(a))
370       array1$(a) = temp$&a
380     END FOR a
390   =3 : REMark descending order data
400     datlen = LEN(entries%)
410     FOR a = entries% - 1 TO 0 STEP -1
420       temp$ = ''
430       IF LEN(a) < datlen THEN temp$ = '000000'(1 TO datlen-LEN(a))
440       array1$((entries%-1)-a) = temp$&a
450     END FOR a
460   =4 : REMark word list in the DATA statements
470     IF entries% > 200 THEN PRINT'200 words maximum!' : STOP
480     RESTORE
490     FOR a = 0 TO entries%-1 : READ array1$(a)
500 END SELect
510 :
520 REMark call and time each routine
530 :
540 COPY_ARRAY : time = DATE : EXCHANGE_SORT array2$
550 TIME_IT 'Exchange sort'
560 REMark PRINT !array2$! : PRINT
570 :
580 COPY_ARRAY : time = DATE : BUBBLE_SORT1 array2$
590 TIME_IT 'Bubble sort 1'
600 REMark PRINT !array2$! : PRINT
610 :
620 COPY_ARRAY : time = DATE : BUBBLE_SORT2 array2$
630 TIME_IT 'Bubble sort 2'
640 REMark PRINT!array2$! : PRINT
650 :
660 COPY_ARRAY : time = DATE : BUBBLE_SORT3 array2$
670 TIME_IT 'Bubble sort 3'
680 REMark PRINT!array2$! : PRINT
690 :
700 COPY_ARRAY : time = DATE : INSERTION_SORT array2$
710 TIME_IT 'Insertion sort'
720 REMark PRINT !array2$! : PRINT
730 :
740 COPY_ARRAY : time = DATE : SHELL_SORT array2$
750 TIME_IT 'Shell sort'
760 REMark PRINT !array2$! : PRINT
770 :
780 COPY_ARRAY : time = DATE : QUICKSORT1 array2$,0,DIMN(array2$)
790 TIME_IT 'Quicksort 1'
800 REMark PRINT !array2$! : PRINT
810 :
820 REMark QUICKSORT2 needs extra  dummy 'highest value' at end of array
830 COPY_ARRAY : array2$(DIMN(array2$)) = 'zzzzzzzzzz'
840 time = DATE : QUICKSORT2 array2$,0,DIMN(array2$)-1
850 TIME_IT 'Quicksort 2'
860 REMark PRINT !array2$(0 TO entries%-2)! : PRINT
870 :
880 STOP
890 :
900 DEFine PROCedure COPY_ARRAY
910   LOCal a
920   FOR a = 0 TO entries% - 1 : array2$(a) = array1$(a)
930 END DEFine COPY_ARRAY
940 :
950 DEFine PROCedure TIME_IT (name$)
960   LOCal dur
970   dur = DATE - time
980   PRINT name$;' took ';dur;' second';
990   IF dur <> 1 THEN PRINT's';
1000   PRINT
1010 END DEFine TIME_IT
1020 :
1030 REMark 200 words as data list for words sorting examples
1040 :
1050 DATA 'Hello','Hell','Halo','QL','PC','One','Two','Three','Threesome'
1060 DATA 'Couple','Single','Quite','Quit','A','a','AA','aa','escape','.'
1070 DATA 'Four','Quartet','Five','Quintet','Six','seven','Severn','Eight'
1080 DATA 'Qubide','QPlane','Aurora','QPAC','QXL',' ','Gold Card','Cable'
1090 DATA 'Super','Qbranch','Qubbesoft','Quo Vadis','TF Services'
1100 DATA 'Upper','Lower','Mixed','upper','lower','mixed','test data'
1110 DATA 'Anything','Whatsoever','Can','Be','Sorted','But','any','some'
1120 DATA 'data','to','test','datas','too','tests','do','done','duplicate'
1130 DATA 'duplicates','once','date','time','for','next','bubble','insert'
1140 DATA 'insrtion','quicksort','Shell','heap','merge','hi','high','lo'
1150 DATA 'low','random','mid','middle','Low','High','Middle','randoms'
1160 DATA 'AAA','aaa','ZZZ','zzz','YYY','yyy','W','X','U','V','u','t','s'
1170 DATA 'r','q','p','m','n','o','l','j','k','b','c','d','e','f','G','H'
1180 DATA 'i','good','bad','mediocre','medium','fancy','great','good'
1190 DATA 'Zebedee','Zee','archive','quill','abacus','archive','1','2','3'
1200 DATA '5','4','0','9','8','7','6','13','11','12','insert','overwrite'
1210 DATA 'functions','keys','key','function','oops','tag','look','read'
1220 DATA 'write','Writes','sets','set','settling','see','settle','set-up'
1230 DATA 'my','your','their','theirs','his','her','our','yours','outline'
1240 DATA 'menu','hard','disk','floppy','drive','drivers','driver'
1250 DATA 'colour','driven','news','review','internet','comms','web','Web'
1260 DATA 'site','trial','index','indexing','indexed','indexer','indexing'
1270 DATA 'what','out','in','cartridge','microdrive','keyboard','membrane'
1280 :
1290 REMark the sorting routines themselves follow
1300 :
1310 DEFine PROCedure EXCHANGE_SORT (array)
1320   LOCal index,findlow,lowest%,highest%,temp$
1330   highest% = DIMN(array) : IF highest% < 1 THEN RETurn
1340   FOR index = 0 TO highest%-1
1350     lowest% = index
1360     FOR findlow = index+1 TO highest%
1370       IF array(findlow) < array(lowest%) THEN lowest% = findlow
1380     END FOR findlow
1390     temp$ = array(lowest%)
1400     array(lowest%) = array(index)
1410     array(index) = temp$
1420   END FOR index
1430 END DEFine EXCHANGE_SORT
1440 :
1450 DEFine PROCedure BUBBLE_SORT1 (array)
1460   LOCal last,index,temp$,highest%
1470   highest% = DIMN(array) : REMark highest subscript
1480   IF highest% < 1 THEN RETurn : REMark need at least 2 items to sort
1490   FOR last = highest% TO 1 STEP -1
1500     FOR index = 1 TO last
1510       IF array(index) < array(index-1) THEN
1520         temp$ = array(index)
1530         array(index) = array(index-1)
1540         array(index-1) = temp$
1550       END IF
1560     END FOR index
1570   END FOR last
1580 END DEFine BUBBLE_SORT1
1590 :
1600 DEFine PROCedure BUBBLE_SORT2 (array)
1610   LOCal highest%,index,temp$,last_swap%
1620   highest% = DIMN(array) : IF highest% < 1 THEN RETurn
1630   last% = highest%
1640   REPeat scan
1650     last_swap% = 0
1660     FOR index = 1 TO last%
1670       IF array(index) < array(index-1) THEN
1680         temp$ = array(index) : array(index) = array(index-1)
1690         array(index-1) = temp$ : last_swap% = index-1
1700       END IF
1710     END FOR index
1720     REMark test for premature end because sorting is complete
1730     IF last_swap% < 1 THEN EXIT scan
1740     last% = last_swap% : REMark where to end next scan
1750   END REPeat scan
1760 END DEFine BUBBLE_SORT2
1770 :
1780 REMark BUBBLE_SORT3 also needs the routine BUBBLE_SORT2
1790 :
1800 DEFine PROCedure BUBBLE_SORT3 (array)
1810   LOCal highest%,rng1%,rng2%,a,temp$,pt1%,pt2%,loop
1820   highest% = DIMN(array) : IF highest% < 1 THEN RETurn
1830   rng1% = highest% DIV 2 : REMark sort up to halfway
1840   rng2% = rng1% + 1
1850   IF rng1% > 0 THEN BUBBLE_SORT2 array(0 TO rng1%)
1860   IF highest% > rng2% THEN BUBBLE_SORT2 array(rng2% TO highest%)
1870   REMark combine or merge the two halves
1880   pt1% = 0 : pt2% = rng2%
1890   REPeat loop
1900     IF pt2% > highest% OR pt1% >= pt2% THEN EXIT loop
1910     IF array(pt2%) < array(pt1%) THEN
1920       temp$ = array(pt2%)
1930       FOR a = pt2% TO pt1%+1 STEP -1 : array(a) = array(a-1)
1940       array(pt1%) = temp$
1950       pt2% = pt2% + 1 : pt1% = pt1% + 1
1960     ELSE
1970       pt1% = pt1% + 1
1980     END IF
1990   END REPeat loop
2000 END DEFine BUBBLE_SORT3
2010 :
2020 DEFine PROCedure INSERTION_SORT (array)
2030   LOCal index,down,highest%,temp$
2040   highest% = DIMN(array) : IF highest% < 1 THEN RETurn
2050   FOR index = 1 TO highest%
2060     temp$ = array(index)
2070     FOR down = index-1 TO 0 STEP -1
2080       IF temp$ >= array(down) THEN array(down+1) = temp$ : EXIT down
2090       array(down+1) = array(down)
2100     NEXT down
2110       array(0) = temp$
2120     END FOR down
2130   END FOR index
2140 END DEFine INSERTION_SORT
2150 :
2160 DEFine PROCedure SHELL_SORT (array)
2170   LOCal ind1,ind2,ind3,interval%,number%,loop,size%
2180   highest% = DIMN(array) : IF highest% < 1 THEN RETurn
2190   size%   = highest%
2200   number% = highest%
2210   REPeat loop
2220     number% = number% DIV 2
2230     FOR ind1 = 0 TO number%
2240       interval% = ind1 + number%
2250       FOR ind2 = interval% TO size% STEP number%
2260         temp$ = array(ind2)
2270         FOR ind3 = ind2 TO interval% STEP -number%
2280           array(ind3) = array(ind3-number%)
2290           IF temp$ >= array(ind3) : array(ind3) = temp$ : EXIT ind3
2300         END FOR ind3
2310         IF temp$ < array(ind1) THEN array(ind1) = temp$
2320       END FOR ind2
2330     END FOR ind1
2340     IF number% = 1 THEN EXIT loop
2350   END REPeat loop
2360 END DEFine SHELL_SORT
2370 :
2380 DEFine PROCedure QUICKSORT1 (array$,bottom,top)
2390   LOCal sort_loop,low,high,ptr
2400   low  = bottom : high = top : ptr = bottom
2410   REPeat sort_loop
2420     IF low >= high THEN EXIT sort_loop
2430     IF array$(low) > array$(high) THEN
2440       temp$        = array$(low)
2450       array$(low)  = array$(high)
2460       array$(high) = temp$
2470       IF ptr = low THEN
2480         low  = low+1  : ptr = high
2490       ELSE
2500         high = high-1 : ptr = low
2510       END IF
2520     ELSE
2530       IF ptr = low THEN high = high-1 : ELSE low = low+1
2540     END IF
2550   END REPeat sort_loop
2560   IF ABS(top - bottom) < 2 THEN RETurn
2570   QUICKSORT1 array$,bottom,ptr - 1
2580   QUICKSORT1 array$,ptr + 1,top
2590 END DEFine QUICKSORT1
2600 :
2610 REMark Quicksort, faster variety, by Marcus Jeffery
2620 :
2630 REMark prepare an array to sort, remembering that this routine needs
2640 REMark a predefined 'highest value entry' at the end of the array
2650 REMark QUICKSORT2 also needs the procedure QS2_PARTITION below
2660 DEFine PROCedure QUICKSORT2 (array,lower,upper)
2670   LOCal part_elem
2680   IF lower < upper THEN
2690     part_elem = upper + 1
2700     QS2_PARTITION lower,part_elem
2710     QUICKSORT2 array,lower,part_elem-1
2720     QUICKSORT2 array,part_elem+1,upper
2730   END IF
2740 END DEFine QUICKSORT2
2750 :
2760 DEFine PROCedure QS2_PARTITION (i,j)
2770   LOCal k,temp$,swap$,loop,inc_k,dec_j,swap
2780   temp$ = array(i) : k = i
2790   REPeat loop
2800     REPeat inc_k
2810       k = k + 1
2820       REMark this is where the 'guaranteed highest value' comes in
2830       IF array(k) >= temp$ THEN EXIT inc_k
2840     END REPeat inc_k
2850     REPeat dec_j
2860       j = j - 1
2870       REMark conversely we don't need a 'guaranteed less than' value
2880       REMark at the start of the array as the sorting process does
2890       REMark this for us anyway
2900       IF array(j) <= temp$ THEN EXIT dec_j
2910     END REPeat dec_j
2920     IF k < j THEN
2930       REMark swap the two entries around
2940       swap$ = array(k) : array(k) = array(j) : array(j) = swap$
2950     ELSE
2960       EXIT loop
2970     END IF
2980   END REPeat loop
2990   array(i) = array(j) : array(j) = temp$
3000 END DEFine QS2_PARTITION
